/* 
 * This is an example program to demonstrate the use of sched_task().
 * On every memory read or write, it schedules a task to complete 10 cycles
 * in the future.
 */

#include "mint.h"

int ref_done(task_ptr ptask);

sim_read(task_ptr ptask)
{
    /* schedule the ref_done() function 10 cycles from now */
    sched_task(ptask, ref_done, ptask->time + 10);
    return T_FREE;
}

sim_write(task_ptr ptask)
{
    /* schedule the ref_done() function 10 cycles from now */
    sched_task(ptask, ref_done, ptask->time + 10);
    return T_FREE;
}

/* This function is called when a read or write completes. */
ref_done(task_ptr ptask)
{
    return T_ADVANCE;
}
