#include "mint.h"

/* define a type for memory reference stats: shared and private */
typedef struct memref_s {
    int prv;
    int shr;
} memref_t;

/* for collecting statistics about events */
struct global_stats {
    memref_t nreads;
    memref_t nwrites;
} Data;

sim_read(task_ptr ptask)
{
    int type;

    type = ptask->pevent->type;

    /* count shared and private reads */
    if (type & E_SHARED)
        Data.nreads.shr++;
    else
        Data.nreads.prv++;
    return T_ADVANCE;
}

sim_write(task_ptr ptask)
{
    int type;

    type = ptask->pevent->type;

    /* count shared and private writes */
    if (type & E_SHARED)
        Data.nwrites.shr++;
    else
        Data.nwrites.prv++;
    return T_ADVANCE;
}

void
sim_done(double elapsed, double cpu_time)
{
    printf("Private: %d reads, %d writes\n",
           Data.nreads.prv, Data.nwrites.prv);
    printf("Shared:  %d reads, %d writes\n",
           Data.nreads.shr, Data.nwrites.shr);
}
