/* 
 * Please read the COPYRIGHT notice included at the top level
 */
/*
 * init.c,v 1.1.1.1 1996/07/18 22:39:55 arsharma Exp
 * Purpose: Initialization
 */

#include "doctor_t.h"
#include "lex.h"
#include "memref.h"
#include "instr.h"
#include "symtab.h"
#include "write.h"

#include <stdio.h>

yyinit ()
{
    extern FILE *yyin;
    extern char input_filename[MAX_ID_LENGTH];
    extern int start_pos;
    extern instr_t **basic_block;
    extern char *aug_buffer;

    if (input_filename[0]) {
	if (!(yyin = fopen (input_filename, "r")))
	    yyerror ("input file not found");
    }
    else
	yyin = stdin;

    /* The pointer to the beginning of the first instruction */
    start_pos = 0;

    /* Allocate the output buffer */
    alloc_output_buf ();

    /* Initialize the symbol table */
    initwords ();

    /*
     * allocate       memory for the basic block pointers
     * Note that memory for each pointer is to be allocated separately
     */
    basic_block = (instr_t **) malloc (sizeof (instr_t *) *
				       MAX_BB_INSTR);

    /* allocate memory for the augmentation buffer */
    aug_buffer = (char *) malloc (sizeof (char) * AUG_BUF_SIZE);

}
